/* ̧قDoxygenpɏĂ܂B				 */
/*! \file *********************************************************************
 *
 * \brief
 *		CC-ADCPʕ
 *
 * \par pLq:
 *      AVR352: CC-ADC̎g
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation: http://www.atmel.com \n
 *		xEҰ: avr@atmel.com
 *
 * $Revision: 4810 $
 * $Date: 2008-11-04 12:22:27 +0100 (ti, 04 nov 2008) $  \n
 *
 * 쌠 (c) 2008, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 ******************************************************************************/

#include <ioavr.h>
#include "config.h"
#include "ccadc.h"

/******************************************************************************
 S(̧ى͈)ԕϐ
******************************************************************************/
//volatile uint8_t ccAdcInputPolarity;

volatile int32_t CCADC_accResult;
volatile int16_t CCADC_iccResult;

union CCADC_conversionFlag_union
{
	uint8_t allFlags;
	struct
	{
		uint8_t accResultReady : 1 ;
		uint8_t iccResultReady : 1 ;
		uint8_t regularCurrentDetected : 1 ;
	};
} volatile CCADC_statusFlags = {0x00};

/******************************************************************************
 I֐l^錾
******************************************************************************/

static void CCADC_PolarityManager ( void );


/*! \brief CC-ADCƒd̍\ݒ
 *
 *  CC-ADC͊JnꂸA\ݒ肾ȂƂɒӂĂBCC-ADC
 *  CCADC_Mode_Select()֐ɂĊJn܂B\n
 *
 *  \note CC-ADCg߂޷ެߎQƊdčZȂ
 *		  Ȃ܂B
 *
 *  \param accConversionTime	[ACCT_128, ACCT_256, ACCT_512, ACCT_1024]
 *  \param rccSamplingInterval	[RSI_256, RSI_512, RSI_1024, RSI_2048]
 *  \param regularCurrentLevel	maŗ^܂B
 */
void CCADC_Init ( CCADC_AccConvPeriod_t accConversionTime, CCADC_RccConvPeriod_t rccSamplingInterval, uint16_t regularCurrentLevel )
{ 
	// doݒ
	CADRC = ((regularCurrentLevel<<RCC_SCALE) / RCC_STEP_SIZE_mA_SCALED);

	/* CC-ADC\ݒύX܂ő҂(O̕ύX̂߂ɸۯ̈Ԃ̓
	 * ҂)B
	 */
	while( CADCSRA & (1<<CADUB) )
	{
	}

	/* CC-ADCݒ菑
	 * - CC-ADCϊԂƒd̎Ԋu\n
	 * - VCC-ADCϊԂƓd̎ԊuI\n
	 * - Ԃɏ]ċɐޯĂݒ
	 */
	CADCSRA = (CADCSRA & ~( (1<<CADAS1)|(1<<CADAS0)|(1<<CADSI1)|(1<<CADSI0)|(1<<CADPOL) )) |
			  ((uint8_t)accConversionTime | (uint8_t)rccSamplingInterval) |
			  CCADC_POLARITY_POS;
}

/*! \brief CC-ADC̓`ԂI
 *
 *  ȉI
 *   - CCADC_DISABLE (CC-ADC֎~A荞݋֎~Ɖ)
 *   - CCADC_IAC (CC_ADCAuƗݐς̗ϊ荞݂𐶐)
 *   - CCADC_IC (CC_ADCAuϊ荞݂𐶐)
 *   - CCADC_ACC (CC_ADCAݐϕϊ荞݂𐶐)
 *   - CCADC_RCC (d󋵋 - ݐϊ킪܂B)\n
 *
 *  \note Ƌ֎~CC-ADC̍\ݒύX܂B`ԂƊ荞݂
 *		  Ƌ֎~\n
 *
 *  \note CC-ADCg߂޷ެߎQƊdčZȂ
 *		  Ȃ܂B
 *
 *  \param  mode	`
 */
void CCADC_SetMode ( CCADC_modes_t mode )
{
	//!< ݊JnOɸۯ̈Ԃ̓҂
	while( CADCSRA & (1<<CADUB) )
	{
	};

	switch( mode )
	{
	    case CCADC_DISABLE:
			// CC-ADC֎~A荞݋֎~(ۗ̊荞݂)
			CADCSRA = CADCSRA & ~( (1<<CADEN) | (1<<CADSE) );
			CADCSRB = (0<<CADACIE) | (0<<CADRCIE) | (0<<CADICIE) | (1<<CADACIF) | (1<<CADRCIF) | (1<<CADICIF);
			break;

	    case CCADC_IAC:
			// ICCACC̗荞ݓCC-ADC(ۗ̊荞݂)
			CADCSRA = ( CADCSRA & ~(1<<CADSE) ) | (1<<CADEN);
			CADCSRB = (1<<CADACIE) | (0<<CADRCIE) | (1<<CADICIE) | (1<<CADACIF) | (1<<CADRCIF) | (1<<CADICIF);
			break;

	    case CCADC_ICC:
			// ICC荞ݓCC-ADC(ۗ̊荞݂)
			CADCSRA = ( CADCSRA & ~(1<<CADSE) ) | (1<<CADEN);
			CADCSRB = (0<<CADACIE) | (0<<CADRCIE) | (1<<CADICIE) | (1<<CADACIF) | (1<<CADRCIF) | (1<<CADICIF);
			break;

	    case CCADC_ACC:
			// ACC荞ݓCC-ADC(ۗ̊荞݂)
			CADCSRA = ( CADCSRA & ~(1<<CADSE) ) | (1<<CADEN);
			CADCSRB = (1<<CADACIE) | (0<<CADRCIE) | (0<<CADICIE) | (1<<CADACIF) | (1<<CADRCIF) | (1<<CADICIF);
			break;

	    case CCADC_RCC:
			// RCCICC̊荞ݓCC-ADC(RCCܰނ޲NICC)
			CADCSRA = CADCSRA | (1<<CADSE) | (1<<CADEN);
			CADCSRB = (0<<CADACIE) | (1<<CADRCIE) | (1<<CADICIE) | (1<<CADACIF) | (1<<CADRCIF) | (1<<CADICIF);  
			break;

		default:
			break;
	}
}

/*! \brief CC-ADCICC/ACCRCC삩̏
 *
 *  \note CC-ADCg߂޷ެߎQƊdčZȂ
 *		  Ȃ܂B
 *
 *  \retval mode	[CCADC_RCC, CCADC_IAC (for ICC, ACC or IAC) ]
 */
uint8_t CCADC_GetMode ( void )
{
	//!< ԓǂݍݑOɸۯ̈Ԃ̓҂
	while( CADCSRA & (1<<CADUB) )
	{
	}

	if( CADCSRA & (1<<CADSE) )
	{
		return CCADC_RCC;
	}else
	{
		return CCADC_IAC;
	}
}

/*! \brief CC-ADCݐϕϊ̌ʂԂ܂B
 *
 *  t32ޯĂƂėݐϕϊ18ޯĕtʂԂ܂B̌ʂ͕Ԃ
 *  O24.8tŒ菬_`g悤Ɏړx߂܂B
 *
 *  \note CC-ADCg߂޷ެߎQƊdčZȂ
 *		  Ȃ܂B
 *
 *  \retval result	24.8tŒ菬_`ŕԂ錋
 */
int32_t CCADC_GetAccResult ( void )
{
	int32_t result;
	uint8_t interruptState = __save_interrupt();

	__disable_interrupt();
	result = CCADC_accResult;
	__restore_interrupt(interruptState);

	return result;
}

/*! \brief CC-ADCuϊ̌ʂԂ܂B
 *
 *  (13ޯĂɑ΂Wް^Ȃ)uϊ̕t13ޯĂ̌ʂ𕄍t
 *  16ޯĂƂĕԂ܂B
 *
 *  \note CC-ADCg߂޷ެߎQƊdčZȂ
 *		  Ȃ܂B
 *
 *  \retval current		(mA)
 */
int32_t CCADC_GetIccResult ( void )
{
	int16_t result;
	uint8_t interruptState = __save_interrupt();

	__disable_interrupt();
	result = CCADC_iccResult;
	__restore_interrupt(interruptState);

	// 13ޯČʂACCʂ̂悤18ޯĂɎړx
	return (int32_t)(result * (1<<5));
}

/*! \brief CC-ADC͋ɐ؂ւ̎𐧌
 *
 *  \ref CONVERSION_COUNTϊCC-ADC͋ɐύX܂B͕ϊA
 *  \Ȍ蒼ɍsׂȂ̂ŁÅ֐ADCϊ荞ٰ݂ɑg
 *  ܂܂B̏ꏊĂ΂ׂł͂ȂA]āAstatic/Ǐ̧ى
 *  ͂łB
 */
#pragma inline = forced
static void CCADC_PolarityManager ( void )
{
	static uint8_t polarityCounter = CONVERSION_COUNT;

	polarityCounter--;
	if(polarityCounter == 0){
		CADCSRA ^= (1<<CADPOL);
		polarityCounter = CONVERSION_COUNT;
	}
}

/*! \brief VCC-ADC̗ݐϓdʂ̔fɎg܂B
 *
 *  ׸ނ荞݂ɂĂ౸邽߁A̱͂̊ԂɑS
 *  荞݂֎~邱Ƃɂĕی삳܂B
 *
 *  \retval bool	VʏȂ^AȂ΋UԂ܂B
 */
bool CCADC_isAccResultReady ( void )
{
	uint8_t interruptState = __save_interrupt();
	__disable_interrupt();

	bool flagState = CCADC_statusFlags.accResultReady;
	CCADC_statusFlags.accResultReady = false;

	__restore_interrupt( interruptState );

	return flagState;
}

/*! \brief VCC-ADC̏udʂ̔fɎg܂B
 *
 *  ׸ނ荞݂ɂĂ౸邽߁A̱͂̊ԂɑS
 *  荞݂֎~邱Ƃɂĕی삳܂B
 *
 *  \retval bool	VʏȂ^AȂ΋UԂ܂B
 */
bool CCADC_isIccResultReady ( void )
{
	uint8_t interruptState = __save_interrupt();
	__disable_interrupt();

	bool flagState = CCADC_statusFlags.iccResultReady;
	CCADC_statusFlags.iccResultReady = false;

	__restore_interrupt( interruptState );

	return flagState;
}

/*! \brief CC-ADCudϊ荞
 */
#pragma vector= CCADC_CONV_vect
__interrupt void Ccadc_Icc_ISR ( void )
{
	if( CADCSRA & (1<<CADPOL) )
	{
		CCADC_iccResult = -CADIC;
	}else
	{
		CCADC_iccResult = CADIC;
	}
	CCADC_statusFlags.iccResultReady = true;
}

/*! \brief CC-ADCd臒lʉߊ荞
 */
#pragma vector= CCADC_REG_CUR_vect
__interrupt void Ccadc_Rcc_ISR ( void )
{
	CCADC_statusFlags.regularCurrentDetected = true;
}

/*! \brief CC-ADCݐϓdϊ荞
 */
#pragma vector= CCADC_ACC_vect
__interrupt void Ccadc_Acc_ISR ( void )
{
	if( CADCSRA & (1<<CADPOL) )
	{
		CCADC_accResult = - CADAC;
	}else
	{
		CCADC_accResult = CADAC;
	}
	CCADC_PolarityManager();
	CCADC_statusFlags.accResultReady = true;
}
